"
 COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

EditField subclass:#FilenameEditField 
       instanceVariableNames:'directoriesOnly filesOnly'
       classVariableNames:   ''
       poolDictionaries:''
       category:'Views-Text'
!

FilenameEditField comment:'
COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

$Header: /cvs/stx/stx/libwidg2/Attic/FNmEdtFld.st,v 1.10 1995-05-03 00:42:24 claus Exp $
'!

!FilenameEditField class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1994 by Claus Gittinger
	      All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
"
$Header: /cvs/stx/stx/libwidg2/Attic/FNmEdtFld.st,v 1.10 1995-05-03 00:42:24 claus Exp $
"
!

documentation
"
    like a normal editField, but does filename-completion on the last word of
    the contents, when TAB is pressed.
    Filename completion ignores regular files if directoriesOnly is true,
    and ignores directories, if filesOnly is true. Both default to false.
"
! !

!FilenameEditField methodsFor:'initialization'!

initialize
    super initialize.
    directoriesOnly := filesOnly := false.
!

realize
    "move the cursor to the end - thats the most interresting part of
     a filename
    "
    super realize.
    self cursorToEndOfLine.
! !

!FilenameEditField methodsFor:'accessing'!

directoriesOnly
    "set to expand names for directories only"

    directoriesOnly := true.
!

filesOnly
    "set to expand names for files only"

    filesOnly := true.
!

initialText:aString selected:aBoolean
    "move the cursor to the end - thats the most interresting part of
     a filename
    "

    super initialText:aString selected:aBoolean.
    self cursorToEndOfLine.
! !

!FilenameEditField methodsFor:'event handling'!

keyPress:key x:x y:y
    "handle tab for filename completion.
     Bug: it completes the last word; it should complete the
	  word before the cursor."

    |s f matchSet nMatch name words dir|

    enabled ifTrue:[
	((key == #Tab)
	or:[key == #FilenameCompletion]) ifTrue:[
	    s := self contents.
	    "
	     find the last word ...
	    "
	    words := s asCollectionOfWords.
	    f := words last asFilename.
	    matchSet := f filenameCompletion.
	    dir := f directory.
	    directoriesOnly ifTrue:[
		matchSet := matchSet select:[:aFilename |
		    (dir construct:aFilename) isDirectory
		].
	    ] ifFalse:[
		filesOnly ifTrue:[
		    matchSet := matchSet select:[:aFilename |
			(dir construct:aFilename) isDirectory not
		    ].
		]
	    ].

	    (nMatch := matchSet size) ~~ 1 ifTrue:[
		"
		 more than one possible completion -
		"
		self changed:#directory with:f directoryName.
		device beep
	    ].
	    "
	     even with more than one possible completion,
	     f's name is now common prefix
	    "
	    name := f asString.
	    nMatch == 1 ifTrue:[
		"
		 exactly one possible completion -
		"
		f := dir construct:matchSet first.

		directoriesOnly ifTrue:[
		    name := f asString
		] ifFalse:[
		    f isDirectory ifTrue:[
			(name endsWith:(Filename separator)) ifFalse:[
			    name := (f construct:'') asString
			].
		    ].
		]
	    ].
	    "
	     construct new contents, by taking
	     last words completion
	    "
	    s := ''.
	    1 to:(words size - 1) do:[:idx |
		s := s , (words at:idx) , ' '
	    ].
	    s := s , name.
	    self contents:s.
	    self cursorToEndOfLine.
	    ^ self
	].
    ].
    ^ super keyPress:key x:x y:y.
! !
